package ImageSizeModifier::CMS;

use strict;

use LWP::Simple;
use Image::Size;

sub build_page {
    my ($cb, %args) = @_;

    my $blog = $args{blog};
    my $tmpl = $args{template};

    my $plugin = MT->component("ImageSizeModifier");
    my $template_ids = $plugin->get_config_value('template_ids', 'blog:' . $blog->id);

    my $id = $tmpl->id;
    return if $template_ids !~ /$id/;

    my $content = $args{content};
    my @result = _insert_width_height($$content, $blog);
    $$content = join("\n", @result);

    return 1;
}

sub _width_height {
    my ( $src, $blog ) = @_;

    my $plugin = MT->component("ImageSizeModifier");
    my $width = $plugin->get_config_value('width', 'blog:' . $blog->id);

    my $content = get($src);
    if (! $content) {
        return '';
    }
    my ($x, $y) = imgsize(\$content);

    if ( $x > $width ) {
        $y = ( $width / $x ) * $y;
        $x = $width;
    }
    return ' width="' . $x . '" height="' . $y .'" ';
}

sub _insert_width_height {
    my ( $content, $blog ) = @_;
    $content =~ s/(<\s*img\s+(?:alt="[^"]*"\s+)*src="([^"]*)")\s+(?:alt="[^"]*"\s+)*(?:class="[^"]*"\s+)*(?:style="[^"]*"\s+)*((?:width="[^"]*"\s+)*height="[^"]*"(?:\s+width="[^"]*"\s+)*)/
        $1 . _width_height($2, $blog)
    /ige;
    $content;
}

1;
